"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _theming = require("@storybook/theming");

var _constants = require("./constants");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const Message = _theming.styled.p({
  textAlign: 'center'
});

const Iframe = _theming.styled.iframe({
  border: '0 none',
  height: '100%',
  width: '100%'
});

const Panel = ({
  active,
  channel
}) => {
  const [url, setUrl] = (0, _react.useState)('');
  (0, _react.useEffect)(() => {
    const listener = newUrl => setUrl(newUrl);

    channel.on(_constants.EVENTS.UPDATE, listener);
    return () => channel.off(_constants.EVENTS.UPDATE, listener);
  }, [channel]);

  if (!active) {
    return null;
  }

  if (!url) {
    return /*#__PURE__*/_react.default.createElement(Message, null, "Playroom has been disabled for this story.");
  }

  return /*#__PURE__*/_react.default.createElement(Iframe, {
    key: url,
    allowFullScreen: true,
    src: url,
    title: "Playroom"
  });
};

var _default = Panel;
exports.default = _default;