"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withPlayroom = void 0;

var _utils = require("playroom/utils");

var _react = _interopRequireDefault(require("react"));

var _reactElementToJsxString = _interopRequireDefault(require("react-element-to-jsx-string"));

var _addons = require("@storybook/addons");

var _constants = require("./constants");

var _utils2 = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable import/prefer-default-export */
const Story = ({
  storyFn,
  context,
  settings: {
    parameters
  }
}) => {
  const {
    url,
    code,
    reactElementToJSXStringOptions
  } = (0, _utils2.getOptions)(parameters);
  const story = storyFn(context);
  const jsxString = code || (0, _reactElementToJsxString.default)(story, reactElementToJSXStringOptions);

  const channel = _addons.addons.getChannel();

  const codeUrl = url && (0, _utils.createUrl)({
    baseUrl: url,
    code: jsxString
  });
  channel.emit(_constants.EVENTS.UPDATE, codeUrl);
  return story;
};

const withPlayroom = (0, _addons.makeDecorator)({
  name: 'withPlayroom',
  parameterName: _constants.PARAM_KEY,
  wrapper: (storyFn, context, settings) => /*#__PURE__*/_react.default.createElement(Story, {
    storyFn: storyFn,
    context: context,
    settings: settings
  })
});
exports.withPlayroom = withPlayroom;