import React, { useEffect, useState } from 'react';
import { styled } from '@storybook/theming';
import { EVENTS } from './constants';
const Message = styled.p({
  textAlign: 'center'
});
const Iframe = styled.iframe({
  border: '0 none',
  height: '100%',
  width: '100%'
});

const Panel = ({
  active,
  channel
}) => {
  const [url, setUrl] = useState('');
  useEffect(() => {
    const listener = newUrl => setUrl(newUrl);

    channel.on(EVENTS.UPDATE, listener);
    return () => channel.off(EVENTS.UPDATE, listener);
  }, [channel]);

  if (!active) {
    return null;
  }

  if (!url) {
    return /*#__PURE__*/React.createElement(Message, null, "Playroom has been disabled for this story.");
  }

  return /*#__PURE__*/React.createElement(Iframe, {
    key: url,
    allowFullScreen: true,
    src: url,
    title: "Playroom"
  });
};

export default Panel;