/* eslint-disable import/prefer-default-export */
import { createUrl } from 'playroom/utils';
import React from 'react';
import reactElementToJSXString from 'react-element-to-jsx-string';
import { addons, makeDecorator } from '@storybook/addons';
import { EVENTS, PARAM_KEY } from './constants';
import { getOptions } from './utils';

const Story = ({
  storyFn,
  context,
  settings: {
    parameters
  }
}) => {
  const {
    url,
    code,
    reactElementToJSXStringOptions
  } = getOptions(parameters);
  const story = storyFn(context);
  const jsxString = code || reactElementToJSXString(story, reactElementToJSXStringOptions);
  const channel = addons.getChannel();
  const codeUrl = url && createUrl({
    baseUrl: url,
    code: jsxString
  });
  channel.emit(EVENTS.UPDATE, codeUrl);
  return story;
};

export const withPlayroom = makeDecorator({
  name: 'withPlayroom',
  parameterName: PARAM_KEY,
  wrapper: (storyFn, context, settings) => /*#__PURE__*/React.createElement(Story, {
    storyFn: storyFn,
    context: context,
    settings: settings
  })
});